package com.izouma.zhirongip.web.demand;

import com.izouma.zhirongip.repo.SettingRepo;
import com.izouma.zhirongip.utils.SecurityUtils;
import com.izouma.zhirongip.web.BaseController;
import com.izouma.zhirongip.domain.demand.LogoDemand;
import com.izouma.zhirongip.service.demand.LogoDemandService;
import com.izouma.zhirongip.dto.PageQuery;
import com.izouma.zhirongip.exception.BusinessException;
import com.izouma.zhirongip.repo.demand.LogoDemandRepo;
import com.izouma.zhirongip.utils.ObjUtils;
import com.izouma.zhirongip.utils.excel.ExcelUtils;

import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/logoDemand")
@AllArgsConstructor
public class LogoDemandController extends BaseController {
    private final LogoDemandService logoDemandService;
    private final LogoDemandRepo    logoDemandRepo;
    private final SettingRepo       settingRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public LogoDemand save(@RequestBody LogoDemand record) {
        if (record.getId() != null) {
            LogoDemand orig = logoDemandRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return logoDemandRepo.save(orig);
        }
        record.setUserId(SecurityUtils.getAuthenticatedUser().getId());
        return logoDemandRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<LogoDemand> all(@RequestBody PageQuery pageQuery) {
        return logoDemandService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public LogoDemand get(@PathVariable Long id) {
        LogoDemand record = logoDemandRepo.findById(id).orElseThrow(new BusinessException("无记录"));
        settingRepo.findById(record.getCategory())
                .ifPresent(setting -> record.setCategoryName(setting.getName()));
        if(record.getModeId()!=null){
            settingRepo.findById(record.getModeId())
                    .ifPresent(setting -> record.setMode(setting.getName()));
        }
        return record;
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        logoDemandRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<LogoDemand> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @PreAuthorize("hasRole('ADMIN')")
    @ApiOperation("审核")
    @PostMapping("/audit")
    public void audit(@RequestParam Long id, @RequestParam boolean pass, String remark) {
        logoDemandService.audit(id, pass, remark);
    }
}

